/**
 * @license Copyright (c) 2003-2019, CKSource - Frederico Knabben. All rights reserved.
 * For licensing, see https://ckeditor.com/legal/ckeditor-oss-license
 */

CKEDITOR.editorConfig = function( config ) {
	// Define changes to default configuration here.
	// For complete reference see:
	// https://ckeditor.com/docs/ckeditor4/latest/api/CKEDITOR_config.html

	// The toolbar groups arrangement, optimized for two toolbar rows.
    config.extraPlugins = "justify,showblocks,codemirror";

	config.toolbarGroups = [
		{ name: 'clipboard',   groups: [ 'clipboard', 'undo' ] },
		{ name: 'editing',     groups: [ 'find', 'selection' ] },
		{ name: 'links' },
		{ name: 'insert' },
		{ name: 'forms' },
		{ name: 'tools' },
		{ name: 'document',	   groups: [ 'mode', 'document', 'doctools' ] },
		{ name: 'others' },
		'/',
		{ name: 'paragraph',   groups: [ 'justify', 'list', 'indent', 'blocks', 'align', 'bidi', 'paragraph' ] },
		{ name: 'basicstyles', groups: [ 'basicstyles', 'cleanup' ] },
		{ name: 'styles',      groups: [ 'styles' ] }
	];

	// Remove some buttons provided by the standard plugins, which are
	// not needed in the Standard(s) toolbar.
	// config.removeButtons = 'Underline,Subscript,Superscript';

	// Set the most common block elements.
	config.format_tags = 'p;h1;h2;h3;pre;small';
    config.format_small = { element : 'small' };

	// Simplify the dialog windows.
	config.removeDialogTabs = 'image:advanced;link:advanced';
    
    config.removeButtons = 'undefined,Styles,UncommentSelectedRange,CommentSelectedRange';

    config.entities = false;
    config.autoGrow_onStartup = true;   
    config.allowedContent = true; 
    config.protectedSource.push( /<\?[\s\S]*?\?>/g );   // Safe PHP Code
    config.filebrowserBrowseUrl = '/wp-content/plugins/dovi-html-templates/assets/libs/browse.php';
    config.filebrowserUploadUrl = '/wp-content/plugins/dovi-html-templates/assets/libs/upload.php';
    
};
