jQuery(document).ready(function() {

    if (document.getElementById('template')) {
        CKEDITOR.plugins.addExternal( 'codemirror', '/wp-content/plugins/dovi-html-templates/assets/js/codemirror/', 'plugin.js' );
        CKEDITOR.replace( jQuery('#template').attr('name'), {
            language: 'hu',
            customConfig: '/wp-content/plugins/dovi-html-templates/assets/js/editor-config.js'
        });
    }
    
});


function addNewTemplate() {
    var title = prompt(ADD_NEW_TEMPLATE_LABEL, title);
    if (title != null && title != '') {

        var data_tmp = {action : 'dovi_html_templates_new_template',
                        title  : title};
        jQuery.ajax({
            url      : dovi_html_templates_ajax_object.ajax_url,
            dataType : 'json',
            type     : 'POST',
            data     : data_tmp,
            success  : function(res, result){
                if (res.status == 1) {
                    var url = window.location.href;    
                    if (url.indexOf('?') > -1){
                       url += '&file=' + res.file;
                    } else {
                       url += '?file=' + res.file;
                    }
                    window.location.href = url;
                } else {
                    alert(res.message);
                }
            },
            error: function (request, status, error) {
                alert('AJAX error : ' + status);
            } 
        });
    }
}

function deleteTemplate(filename) {
    jQuery('#button_delete_icon').removeClass('dashicons-trash');
    jQuery('#button_delete_icon').addClass('dashicons-update');
    jQuery('#button_delete_icon').addClass('spin');

    var data_tmp = {action : 'dovi_html_templates_delete_template',
                    file   : filename};
    jQuery.ajax({
        url      : dovi_html_templates_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data_tmp,
        success  : function(res, result){
            if (res.status == 1) {
                var url = home_url + 'wp-admin/options-general.php?page=dovi-html-templates-setting-admin';    
                window.open(url, '_self');
            } else {
                alert(res.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function editOtherTemplate(filename) {
    var url = home_url + 'wp-admin/options-general.php?page=dovi-html-templates-setting-admin&file='+filename;    
    window.open(url, '_self');
}

function saveTextToFile() {
    jQuery('#button_save_icon').removeClass('dashicons-yes');
    jQuery('#button_save_icon').addClass('dashicons-update');
    jQuery('#button_save_icon').addClass('spin');
    var data = {
            action : 'dovi_html_templates_save_template',
            file   : jQuery('#template').attr('data-file'),
            html   : CKEDITOR.instances['template'].getData()
        };

    jQuery.ajax({
        url      : dovi_html_templates_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(res, result){
            if (res.status == 1) {
                // Template saved
                jQuery('#button_save_icon').removeClass('spin');
                jQuery('#button_save_icon').removeClass('dashicons-update');
                jQuery('#button_save_icon').addClass('dashicons-yes');
            } else {
                alert(res.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}


