<!DOCTYPE html>
<?php
    if (!defined('DS')) {
        define( 'DS', DIRECTORY_SEPARATOR );
    }
    
    $path = str_replace('plugins/dovi-html-templates/assets/libs', '', dirname(__file__));
    define('PATH', $path .DS. 'uploads' .DS);

    $images_dir = '/wp-content/uploads';

    if (isset($_REQUEST['folder'])) {
        $folder = $_REQUEST['folder'];
    } else {
        $folder = '';
    }
    
    include(dirname(__file__).DS.'files.php');
    $files = new JFiles(PATH . $folder);
    
    $dirs = array();
    if ($folder != '') {
        $link = explode(DS, $folder);
        unset($link[count($link)-1]);
        $link = implode(DS, $link); 
        $dir = array('link'  => $link,
                     'title' => '[..]',
                     'icon'  => '/wp-content/plugins/dovi-html-templates/assets/images/up.png');
        $dirs[] = $dir;
    }
    $d = $files->getFolders();
    foreach ($d as $item) {
        if ($item['name'] != '_thumbs') {
            $dir = array('link'  => $folder .DS. $item['name'],
                         'title' => $item['title'],
                         'icon'  => '/wp-content/plugins/dovi-html-templates/assets/images/folder.png');
            $dirs[] = $dir;
        }
    }
    
    $images = array();
    $files->allowExt = array('jpg', 'gif', 'tif', 'png');
    $img = $files->getFiles();
    foreach ($img as $item) {
        if (file_exists($item['dir'].DS.'_thumbs'.DS.$item['filename'])) {
            $thumb = $images_dir.DS.$folder.DS.'_thumbs'.DS.$item['filename']; 
        } else {
            $thumb = $images_dir.DS.$folder.DS.$item['filename'];
        }
        if ($item['title'] != $item['name']) {
            $title = $item['title'];
        } else {
            $title = '';
        }
        $image = array('filename' => $images_dir . $folder .DS. $item['filename'],
                       'title' => $title,
                       'thumb' => $thumb);
        $images[] = $image;
    }
    
?>
<html lang="hu">
<head>
    <meta charset="UTF-8" />
    <title>Browsing images</title>
    <script>
        var folder = '<?php echo $folder;?>';
        
        // Helper function to get parameters from the query string.
        function getUrlParam( paramName ) {
            var reParam = new RegExp( '(?:[\?&]|&)' + paramName + '=([^&]+)', 'i' );
            var match = window.location.search.match( reParam );

            return ( match && match.length > 1 ) ? match[1] : null;
        }
        // Simulate user action of selecting a file to be returned to CKEditor.
        function returnFileUrl(fileUrl, altText) {
        /*
            var funcNum = getUrlParam( 'CKEditorFuncNum' );
            // var fileUrl = '/path/to/file.txt';
            window.opener.CKEDITOR.tools.callFunction( funcNum, fileUrl );
            window.close();
        */
            var funcNum = getUrlParam( 'CKEditorFuncNum' );
            // var fileUrl = 'http://c.cksource.com/a/1/img/sample.jpg';
            window.opener.CKEDITOR.tools.callFunction( funcNum, fileUrl, function() {
                // Get the reference to a dialog window.
                var dialog = this.getDialog();
                // Check if this is the Image Properties dialog window.
                if ( dialog.getName() == 'image' ) {
                    // Get the reference to a text field that stores the "alt" attribute.
                    var element = dialog.getContentElement( 'info', 'txtAlt' );
                    // Assign the new value.
                    if ( element )
                        element.setValue( altText );
                }
                // Return "false" to stop further execution. In such case CKEditor will ignore the second argument ("fileUrl")
                // and the "onSelect" function assigned to the button that called the file manager (if defined).
                // return false;
            } );
            window.close();        
        }
        
        function loadFolder(path) {
            var url = window.location.href;    
            if (url.indexOf('?') > -1){
               url += '&folder='+path
            }else{
               url += '?folder='+path
            }
            window.location.href = url;            
        }
    </script>
    <style>
        .thumbnail {
            border: 1px solid #ccc;
            border-radius: 4px;
            padding: 3px;
            margin:4px;
            display: block;
            float: left;
            font-family: Verdana, Arial, Helvetica, Sans-serif;
            font-size: 80%;
            color: #444;
            cursor: pointer;
        }
        .thumbnail div {
            width: 128px;
            overflow: hidden;
        }
        .thumbnail img {
            max-width: 128px;
        }
    </style>
</head>
<body>
    <div>
        <?php foreach ($dirs as $dir) : ?>
            <div class="thumbnail" ondblclick="loadFolder('<?php echo $dir['link'];?>');">
                <div>
                    <img src="<?php echo $dir['icon'];?>" />
                </div>
                <div style="text-align: center;">
                    <?php echo $dir['title'];?>
                </div>
            </div>        
        <?php endforeach; ?>
        <?php foreach ($images as $img) : ?>
            <div class="thumbnail" ondblclick="returnFileUrl('<?php echo $img['filename'];?>', '<?php echo $img['title'];?>');">
                <div>
                    <img src="<?php echo $img['thumb'];?>" />
                </div>
                <div style="text-align: center;">
                    <?php echo $img['title'];?>
                </div>
            </div>        
        <?php endforeach; ?>
    </div>
    <div style="clear: both;"></div>
</body>
</html>