<?php
class DoviHtmlTemplatesSettingsPage
{

    public function __construct()
    {
        add_action( 'admin_menu', array( $this, 'add_plugin_page' ) );
        add_action( 'admin_init', array( $this, 'page_init' ) );
    }

    public function add_plugin_page()
    {
        // This page will be under "Settings"
        add_options_page(
            'Settings Admin', 
            __('Dovi HTML templates settings', 'dovi-html-templates'), 
            'manage_options', 
            'dovi-html-templates-setting-admin', 
            array( $this, 'create_admin_page' )
        );
    }


    public function create_admin_page()
    {
        if (!class_exists ('JFiles', false)) {
            include_once(dirname(__FILE__) .DS. 'assets' .DS. 'libs' .DS. 'files.php');
        }
        $files = new JFiles(TEMPLATE_PATH);
        $files->allowExt = array('html');
        $templates = $files->getFiles();
        
        if (isset($_REQUEST['file'])) {
            $templateFile = $_REQUEST['file'];
            $content = file_get_contents(TEMPLATE_PATH .DS. $templateFile);
        } else {
            $templateFile = '';
            $content = '';
        }
        ?>
        <div class="wrap">
            <h1><?php echo __('HTML Templates', 'dovi-html-templates');?></h1>
            <div>
            <?php if ( count($templates) < 1) : ?>
                <?php echo __('None templates. Please create first!', 'dovi-html-templates');?>
                <button onclick="addNewTemplate();" class="button button-primary" style="display: inline-block;float:right;"><span class="dashicons dashicons-plus" style="margin-top:5px;"></span>&nbsp;<?php echo __('Create new template', 'dovi-html-templates');?></button> 
            <?php else: ?>
                <div style="text-align: right;">
                    <?php if ($templateFile != '') : ?>
                    <button onclick="deleteTemplate('<?php echo $templateFile;?>');" class="button button-secondary"><span id="button_delete_icon" class="dashicons dashicons-trash" style="margin-top:5px;"></span>&nbsp;<?php echo __('Delete template', 'dovi-html-templates');?></button> 
                    <?php endif;?>
                    <button onclick="addNewTemplate();" class="button button-primary"><span class="dashicons dashicons-plus" style="margin-top:5px;"></span>&nbsp;<?php echo __('Create new template', 'dovi-html-templates');?></button> 
                </div>
            <?php endif;?>
            <table style="width: 100%;margin-top:20px;">
                <tr>
                    <td width="25%" valign="top">
                        <ul class="templates-list">
                        <?php 
                            foreach ($templates as $item) {
                               echo '<li onclick="editOtherTemplate(\''.$item['filename'].'\');" ';
                               if ($item['filename'] == $templateFile) {
                                    echo 'class="selected-template-item"'; 
                               }
                               echo '>'.$item['title'].'</li>' . "\r\n"; 
                            }
                        ?>
                        </ul>
                    </td>                
                    <td width="75%" valign="top" style="width: 100%;">
                        <?php if ($templateFile != '') : ?>
                        <div class="template-textarea" style="margin-left: 20px;">
                            <textarea class="hide-textarea" name="template" id="template" data-file="<?php echo $templateFile;?>" style="width: 100%;"><?php echo $content;?></textarea>
                        </div>
                        <div style="text-align: right;margin-top:20px;">
                            <button onclick="saveTextToFile();" class="button button-primary"><span id="button_save_icon" class="dashicons dashicons-yes" style="margin-top:5px;"></span>&nbsp;<?php echo __('Save template', 'dovi-html-templates');?></button>
                        </div>
                        <?php else: ?> 
                        <div class="template-message">
                            <span class="dashicons dashicons-arrow-left-alt"></span>&nbsp;
                            <?php echo __('Please select template!', 'dovi-html-templates');?>
                        </div>
                        <?php endif; ?>
                        
                    </td>                
                </tr>
            </table>
        
            </div>
        </div>
        <?php
    }
    
    public function page_init()
    {        

    }    
}