<?php
/*
Plugin Name: Dovi HTML templates
Plugin URI:  http://wpdemo.dovi42.hu/sablonok/
Description: HTML templates insert to content
Version:     1.50
Author:      Dovi
Author URI:  http://dovi42.hu/
License:     private, not published
License URI: 
*/

if ( !defined( 'ABSPATH' ) ) exit;

if (!defined('DS')) {
    define( 'DS', DIRECTORY_SEPARATOR );
}

$template_path = ABSPATH . 'wp-content' .DS. 'uploads' .DS. 'plugin-html-templates';
define('TEMPLATE_PATH', $template_path);


require_once ( dirname(__file__) .DS. 'autoupdate.php' ); 

function dovi_html_templates_update()
{
	$plugin_current_version = '1.50'; // Current version
	$plugin_remote_path     = 'http://update.dovi42.hu/dovi-html-templates/update.php';  
	$plugin_slug            = plugin_basename(__FILE__);
	$license_user           = get_site_url();
	$license_key            = '<optional license key>';

	if ( $license_user && $license_key && $plugin_remote_path )
	{
		new Dovi_HTML_Templates_AutoUpdate ($plugin_current_version, $plugin_remote_path, $plugin_slug, $license_user, $license_key);
	}
}
add_action('init', 'dovi_html_templates_update');

function dovi_html_templates_load_textdomain() {
    load_plugin_textdomain( 'dovi-html-templates', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
}
add_action( 'plugins_loaded', 'dovi_html_templates_load_textdomain' );

function dovi_html_templates_plugin_add_settings_link( $links ) {
    $settings_link = '<a href="options-general.php?page=dovi-html-templates-setting-admin">' . __( 'Templates', 'dovi-html-templates' ) . '</a>';
    array_unshift( $links, $settings_link );
  	return $links;
}
$plugin = plugin_basename( __FILE__ );
add_filter( "plugin_action_links_$plugin", 'dovi_html_templates_plugin_add_settings_link' );

// Add Plugin options set page

if ( is_admin() ){ // admin actions
    dovi_html_templates_check_dir();
    include('dovi-html-templates-setup.php');
    $my_settings_page = new DoviHtmlTemplatesSettingsPage();
} else {
    // non-admin enqueues, actions, and filters
}

function load_admin_dovi_html_templates_styles() {
    global $pagenow;
    
    if (isset($_REQUEST['page'])) {
        $page = $_REQUEST['page'];
    } else {
        $page = '';
    }
    
    if (($pagenow == 'options-general.php') and ($page == 'dovi-html-templates-setting-admin')) {
        wp_enqueue_style('dovi-html-templates-css', plugins_url( 'dovi-html-templates/assets/css/html-templates.css' ), false, '0.0.1' );

        wp_register_script('dovi-html-templates-admin-js', plugins_url( 'dovi-html-templates/assets/js/html-templates.js' ), array('jquery'), false, true);
        wp_localize_script('dovi-html-templates-admin-js', 'dovi_html_templates_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
        wp_localize_script('dovi-html-templates-admin-js', 'ADD_NEW_TEMPLATE_LABEL', __('Add new template label', 'dovi-html-templates') );
        wp_localize_script('dovi-html-templates-admin-js', 'home_url', esc_url( home_url( '/' )));
    	wp_enqueue_script( 'dovi-html-templates-admin-js');

        wp_register_script('dovi-html-templates-ckeditor-js', 'https://cdn.ckeditor.com/4.11.4/standard-all/ckeditor.js', array('jquery'), false, true);
    	wp_enqueue_script( 'dovi-html-templates-ckeditor-js');
    }
    if ( in_array( $pagenow, array( 'post.php', 'page.php', 'post-new.php', 'post-edit.php' ) ) ) {
        wp_enqueue_style('dovi-html-templates-css', plugins_url( 'dovi-html-templates/assets/css/html-templates.css' ), false, '0.0.1' );
        wp_register_script('dovi-html-templates-button-js', plugins_url( 'dovi-html-templates/assets/js/html-templates-button.js' ), array('jquery'), false, true);
        wp_localize_script('dovi-html-templates-button-js', 'dovi_html_templates_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
        wp_enqueue_script( 'dovi-html-templates-button-js');
    }
    
}
add_action( 'admin_enqueue_scripts', 'load_admin_dovi_html_templates_styles' );

function dovi_html_templates_check_dir()
{
    if ( !file_exists(TEMPLATE_PATH) ) {
        mkdir(TEMPLATE_PATH);
        chmod(TEMPLATE_PATH, 0775); 
        $content = '<html><body bgcolor="#FFFFFF"></body></html>';
        $fp = fopen(TEMPLATE_PATH .DS. 'index.html','wb');
        fwrite($fp, $content);
        fclose($fp);
        chmod(TEMPLATE_PATH .DS. 'index.html', 0664); 
    }
}

function dovi_html_templates_new_template()
{

    $title = $_REQUEST['title'];
    
    if (!class_exists ('JFiles', false)) {
        include_once(dirname(__FILE__) .DS. 'assets' .DS. 'libs' .DS. 'files.php');
    }
    $files = new JFiles();
    $alias = $files->getAlias($title);

    dovi_html_templates_check_dir();
    $content = '<!-- '. $title . ' -->';
    if (file_exists(TEMPLATE_PATH .DS. $alias . '.html')) {
        $data = array(
            'status'  => 0,
            'file'    => $alias.'.html',
            'message' => __('Template file exists', 'dovi-html-templates') . ' (' . $alias.'.html)'
        );
        echo json_encode($data);          
        wp_die();
    }
    $ok = file_put_contents(TEMPLATE_PATH .DS. $alias . '.html', $content);
    if ($ok !== false) {
        $status = 1;
        chmod(TEMPLATE_PATH .DS. $alias . '.html', 0664); 
        if (!class_exists('JDescription', false)) {
            include_once(dirname(__FILE__) .DS. 'assets' .DS. 'libs' .DS. 'description.php');
        }
        $desc = new JDescription(TEMPLATE_PATH, true);
        $desc->update($alias.'.html', $title);
        $desc->store();
    } else {
        $status = 0;
        $message = __('File creation error', 'dovi-html-templates') . ' (' . $alias.'.html' . ')';
    }

    $data = array(
        'status'  => 1,
        'file'    => $alias.'.html',
        'message' => $message
    );
    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_dovi_html_templates_new_template', 'dovi_html_templates_new_template' );
add_action( 'wp_ajax_dovi_html_templates_new_template', 'dovi_html_templates_new_template' );

function dovi_html_templates_delete_template()
{

    $filename = $_REQUEST['file'];
    if (file_exists(TEMPLATE_PATH .DS. $filename)) {

        unlink(TEMPLATE_PATH .DS. $filename);

        $data = array(
            'status'  => 1,
            'file'    => $filename,
            'message' => ''
        );
        echo json_encode($data);          
        wp_die();
    } else {
        $data = array(
            'status'  => 0,
            'file'    => $filename,
            'message' => __('File not exists', 'dovi-html-templates') . ' (' . $filename.')'
        );
        echo json_encode($data);          
        wp_die();
    }
}
add_action( 'wp_ajax_nopriv_dovi_html_templates_delete_template', 'dovi_html_templates_delete_template' );
add_action( 'wp_ajax_dovi_html_templates_delete_template', 'dovi_html_templates_delete_template' );

function dovi_html_templates_get_template_content()
{
    $filename = $_REQUEST['file'];
    if (file_exists(TEMPLATE_PATH .DS. $filename)) {
        $html = file_get_contents(TEMPLATE_PATH .DS. $filename);
        $status = 1;
    } else {
        $html = '';
        $status = 0;
        $message = __('File not exists', 'dovi-html-templates') . ' (' . $filename.')';
    }
    $data = array(
        'status'  => $status,
        'file'    => $filename,
        'html'    => $html,  
        'message' => $message
    );
    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_dovi_html_templates_get_template_content', 'dovi_html_templates_get_template_content' );
add_action( 'wp_ajax_dovi_html_templates_get_template_content', 'dovi_html_templates_get_template_content' );



function dovi_html_templates_save_template()
{
    $filename = $_REQUEST['file'];
    $content = $_REQUEST['html'];
    $content = str_replace('\"', '"', $content);
    $content = str_replace("\'", "'", $content);

    $ok = file_put_contents(TEMPLATE_PATH .DS. $filename, $content);
    if ($ok) {
        $status = 1;
        $message = '';
    } else {
        $status = 0;
        $message = __('File save failed', 'dovi-html-templates');
    }
    $data = array(
        'status'  => $status,
        'message' => $message
    );
    echo json_encode($data);          
    wp_die();

}
add_action( 'wp_ajax_nopriv_dovi_html_templates_save_template', 'dovi_html_templates_save_template' );
add_action( 'wp_ajax_dovi_html_templates_save_template', 'dovi_html_templates_save_template' );

function add_dovi_html_templates_media_button() {
    global $pagenow;
    if ( in_array( $pagenow, array( 'post.php', 'page.php', 'post-new.php', 'post-edit.php' ) ) ) {

/*
        $html = '<a href="#TB_inline?width=content&max-height=200&inlineId=dovi-html-templates-block" class="thickbox button" title="' .
                __('Select template to insert into post', 'dovi-html-templates') .
                '"><span class="wp-media-buttons-icon dashicons dashicons-media-code"></span> ' .
                __('Insert template', 'dovi-html-templates') . '</a>';
*/
    }
        $html = '<a href="javascript:void(0);" onclick="dovi_html_templates_show_select_box();" id="dovi-html-insert-template" class="button">'.
                __('Insert template', 'dovi-html-templates') . '</a>';
    echo $html;
}
add_filter('media_buttons', 'add_dovi_html_templates_media_button');

function dovi_html_templates_admin_footer()
{
    global $pagenow;
    if ( in_array( $pagenow, array( 'post.php', 'page.php', 'post-new.php', 'post-edit.php' ) ) ) {
         ?>
        <div id="template-select-box" style="display: none;">
            <h4><?php echo __('Templates', 'dovi-html-templates');?></h4>
            <div class="wrap" style="text-align: left;padding:10px;margin:0;">
                <select id="templates-list" style="display:inline-block;float:left;">
                    <option value=""><?php echo __('--== Please, select template! ==--', 'dovi-html-templates');?></option>
                    <?php
                        if (!class_exists ('JFiles', false)) {
                            include_once(dirname(__FILE__) .DS. 'assets' .DS. 'libs' .DS. 'files.php');
                        }
                        $files = new JFiles(TEMPLATE_PATH);
                        $files->allowExt = array('html');
                        $templates = $files->getFiles();
                        foreach ($templates as $item) {
                            echo '<option value="'.$item['filename'].'">'.$item['title'].'</option>';
                        }
                    
                    ?>
                </select>
                <input onclick="dovi_html_templates_cancel_select();" type="button" class="button" value="<?php echo __('Cancel','dovi-html-templates');?>" style="display:inline-block;float:right;margin-left:4px;"/>
                <button id="template_ok_button" onclick="dovi_html_templates_getSelectedHTML();" type="button" class="button button-primary" style="display:inline-block;float:right;margin-left:4px;"/>
                    <span class="dashicons dashicons-update" style="display:none;margin-top: 4px;"></span>
                    <span class="text"><?php echo __('Ok','dovi-html-templates');?></span>
                </button>
                <div style="clear: both;"></div> 
            </div>
        </div>
        <?php
    }
}
add_action('admin_footer', 'dovi_html_templates_admin_footer', 11);


